/* IMPLEMENTATION ARI... VERSION 0.0 OF 26.5.97 BY WH, WU-WIEN & BU-ISTANBUL*/
/* this file:   mainprob.c */

#include <math.h>
#include "ari.h"


/*the uniform generator*/
unsigned long int urn=0;

double uniform()
{
   urn=(69069*(urn)+1);
   return(urn/4.294967296e9);
}
/*the function returns the probabilities of a discrete distribution
  with triangular shape in the intervall (0,20) with mode 10*/
double histdisc(param,k)
PARAM *param;
long int k;
{ double help;
  if(k>=0&&k<=20) help=(10.-fabs(10.-k))/100.;
  else help=0.; 
  return (help);
}

void main()
{ 
  PARAM par;
  void *poi;
  long int i,k;

  prariopt();

  printf("simple example with known probabilites\n");
  poi=arisetup(histdisc,&par,10,0,20,-1.);
  for(i=1;i<=1000;i++) 
    { k=arisample(poi);}
  free(poi);

/*In the next 3 example the probabilities are known only up to proportionality
  as the domain of the distribution is reduced. An estimate of the
  modal probability must therefore be included in the function call!*/
  printf("\n simple example; domain 10 to 12 \n");
  poi=arisetup(histdisc,&par,10,10,12,0.4);
  for(i=1;i<=1000;i++) 
    { k=arisample(poi);}
  free(poi);
  printf("\n simple example; domain 9 to 10 \n");
  poi=arisetup(histdisc,&par,10,9,10,0.5);
  for(i=1;i<=1000;i++) 
    { k=arisample(poi);}
  free(poi);
  printf("\n simple example; domain 10 only \n");
  poi=arisetup(histdisc,&par,10,10,10,1.);
  for(i=1;i<=1000;i++) 
    { k=arisample(poi);}
  free(poi);

  printf("\nExample what happens if a wrong mode is handed to the set-up\n");
/*If CHECK_ARI 1 was specified in "ari.h" the error is detected
  unless the sample size is very small*/
  poi=arisetup(histdisc,&par,9,0,20,-1.);
  for(i=1;i<=100;i++) 
    { k=arisample(poi);}
  free(poi);

  printf("\nExample what happens if the left or the right border are wrong\n");
  printf("The error can be caught by checking if arisetup returned a NULL-pointer\n");
  poi=arisetup(histdisc,&par,10,10,9,0.5);
  if(poi!=NULL)
  { for(i=1;i<=2;i++) 
    { k=arisample(poi);}
    free(poi);
  }


  printf("\nExample what happens if the left or the right border are wrong\n");
  printf("And the error is not caught by checking the pointer\n");
/*arisetup reports the error in any case.*/
/* arisample reports the error only if CHECK_ARI 1 was specified in "ari.h"*/
/*Otherwise the program terminates with floating exception*/
  poi=arisetup(histdisc,&par,10,10,9,0.5);
  for(i=1;i<=2;i++) 
    { k=arisample(poi);}
  free(poi);



}    





